#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "gtk_conf_list.h"

static char *col_data(int row, int col, void *item)
{
	char s[16];
	sprintf(s, "r%d c%d", row, col);
	return strdup(s);
}

const char *fn_postproc(char *path)
{
	return path;
}

int main(int argc, char *argv[])
{
	GtkWidget *window;
	GtkWidget *vbox, *t;
	gtk_conf_list_t cl;
	const char *cnames[] = {"foo", "path", "src", "bar"};

	cl.num_cols = 4;
	cl.col_names = cnames;
	cl.col_data = 1;
	cl.col_src = 2;
	cl.reorder = 0;
	cl.get_misc_col_data = col_data;
	cl.file_chooser_title = "qwerty";
	cl.file_chooser_postproc = fn_postproc;

	gtk_init(&argc, &argv);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
	gtk_window_set_default_size(GTK_WINDOW(window), 300, 200);
	gtk_window_set_title(GTK_WINDOW(window), "Images");

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(window), vbox);

	t = gtk_conf_list_widget(&cl);

	gtk_box_pack_start(GTK_BOX(vbox), t, TRUE, TRUE, 4);

	gtk_widget_show_all(window);

	gtk_main();

	gtk_main();

	return 0;
}
